; copy trackloader before main prog
; loaded at 7f000

ADDRMAIN=$23800
ADDRTRKLD=$7fd54

		Section	starter,Code
start
; load packed credits		
	move.w	#2,$1c(a1)
	move.l	#$60000,$28(a1)
	move.l	#1733*512,$2c(a1)	; offset
	move.l	#20*512,$24(a1)
	movea.l	4.w,a6
	jsr	-$1c8(a6)

	move.w	#$7fff,$dff09a
	move.w	#$7fff,$dff09c

	lea	starter(pc),a0	; copy to 20000
	lea	$20000,a1
	move.l	#(sizet/4)-1,d7
.cp	move.l	(a0)+,(a1)+
	dbf	d7,.cp

	lea	$20000,a0
	move.l	a0,$80.w	; and start
	trap	#0
;------------------------------------------------- start credits
starter	
	movea.l	#$60000,a0
	moveq	#0,d0
	bsr	Decrunch
	; patch credits - trackload
	lea	$6009e,a0
	move.w	#$4ef9,(a0)+	; jmp
	pea	loadmain(pc)
	move.l	(sp)+,(a0)+
	; start credits -> download main prog at 23800 / return
	jmp	$60000
;-------------------------------------------------- patch main program
patchmain:
	movea.l	#$23800,a0
	moveq	#0,d0
	bsr	Decrunch
; patch main
	; patch trackloader
	lea	$2b72e,a0
	move.w	#$4ef9,(a0)+
	move.l	#ADDRTRKLD,(a0)

	; patch files infos
	lea	$29ee6+4,a0
	lea	Files(pc),a1
	moveq	#11-1,d7
.loop	move.l	(a1)+,(a0)+	; offset
	;move.l	(a1)+,(a0)+	; len sectors or tracks
	lea	8(a0),a0	; skip addr and len if original len used
	dbf	d7,.loop

	; crack 
	; skip check checksum 3 (modify a screen pointer in puma replayer!)
	lea	$2c25e,a0
	move.w	#$6014,(a0)	; bra ok1

	; checksum 2 (in level 1 routine)
	lea	$2ef1a,a0	; or $2ef28
	move.b	#$60,(a0)	; bra

	; skip checksum at level 2
	lea	$3db06,a0
	move.w	#$4e71,(a0)	; nop
	lea	$3dbb8,a0
	move.b	#$60,(a0)	; bra

; do a copy of trackloader at safe place
	lea	TrackLoader(pc),a0
	lea	ADDRTRKLD,a1
	move.l	#(sizetk/4)-1,d7
cp	move.l	(a0)+,(a1)+
	dbf	d7,cp

	jmp	$23800	; start
;-----------------------------------------
loadmain
	lea	FileMain(pc),a0
	bsr.s	TrackLoader
	bra	patchmain
;--------------------------------------- Files list
FileMain dc.l	$23800
	dc.l	1485*512	; main program ice
	dc.l	248*512
Files	dc.l	11*512		;levels track 1
file2	dc.l	195*512		; 198 : track 18
file3	dc.l	358*512		; 363 : track 33
file4	dc.l	520*512		; 528 : track 48
file5	dc.l	675*512		; 693 : track 63
file6	dc.l	842*512		; 869 : track 79
file7	dc.l	963*512		; 990 : track 90
File8	dc.l	1087*512	; loader 1122 : track 102
File9	dc.l	1161*512	; scores ice 1199 : track 109
File10	dc.l	1191*512	; intro ice 1232 : track 112
File11	dc.l	1301*512	; outro ice 1342 : track 122

;----- TrackLoader sector/sector
TrackLoader:	
	include "trackloader.asm"
sizetk=*-TrackLoader

;----------------------------------------- Ice! DePacker
; ICE Depacker
; a0=source
Decrunch:
	include	"tokiunice.asm"

sizet=*-starter

		End
