; copy trackloader before main prog
; loaded at 7f000

ADDRMAIN=$23800
ADDRTRKLD=$7fd54
		Section	starter,Code
start
	btst	#6,$bfe001
	bne.s	.noTrainer
	lea	trainer(pc),a0
	bset	#0,(a0)
.noTrainer
; load packed credits		
	move.w	#2,$1c(a1)
	move.l	#$60000,$28(a1)
	move.l	#1733*512,$2c(a1)	; offset
	move.l	#20*512,$24(a1)
	movea.l	4.w,a6
	jsr	-$1c8(a6)

	move.w	#$7fff,$dff09a
	move.w	#$7fff,$dff09c

	lea	starter(pc),a0	; copy to 20000
	lea	$20000,a1
	move.l	#(sizet/4)-1,d7
.cp	move.l	(a0)+,(a1)+
	dbf	d7,.cp

	lea	$20000,a0
	move.l	a0,$80.w	; and start
	trap	#0
;-----------------------------------------------
starter	
	movea.l	#$60000,a0
	moveq	#0,d0
	bsr	Decrunch
	; patch credits - trackload
	lea	$6009e,a0
	move.w	#$4ef9,(a0)+	; jmp
	pea	loadmain(pc)
	move.l	(sp)+,(a0)+
	; start credits -> download main prog at 23800 / return
	jmp	$60000

patchmain:
	movea.l	#$23800,a0
	moveq	#0,d0
	bsr	Decrunch
; patch main
	; patch trackloader
	lea	$2b72e,a0
	move.w	#$4ef9,(a0)+
	move.l	#ADDRTRKLD,(a0)	; address final trackloader (prog $7F000)

	; patch files infos
	lea	$29ee6+4,a0
	lea	Files(pc),a1
	moveq	#11-1,d7
.loop	move.l	(a1)+,(a0)+	; offset
	;move.l	(a1)+,(a0)+	; len sectors or tracks
	lea	8(a0),a0	; skip addr and len if original len used
	dbf	d7,.loop

	; crack 
	; skip check checksum 3 (modify a screen pointer in puma replayer!)
	; Checksum code at adress:	$2c258
	; checksum from adress:		$29f32	to	$3eda6
	; Adress of counter table:	$26598	
	;
	;start value of counter:	$539d
	;L2c258: 
	; lea -$5D44(a2),a6 ; 26598 - address of counter table
	; tst.l (a6)	
	; beq .zero		; bra ok
	; subq.l #1,(a6)+
	; movea.l (a6),a1	; 29f32
	; move.l (a1)+,d0	; 7836c
	; move.l a1,(a6)+
	; sub.l d0,(a6)		; checksum $E2CB0053
	; bra ok
	;.zero:
	; move.l 8(a6),d0
	; add.l d0,$26594	; ptscreen2
	;ok:

	lea	$2c25e,a0
	move.w	#$6014,(a0)	; bra ok1

	; checksum 2 (in level 1 routine)
	; Checksum code at adress:	$2ef14
	;
	; tst.l $23a82	; = $29ce
	; bne ok
	; move.l $23c56,d0
	; sub.l $23aae,d0 ; $11BC1177
	; beq ok
	;modif: lea $3eb4e,a0
	; add.l d0,(a0)
	; lea 30(a0),a0
	; move.l a0,modif+2
	;ok:

	lea	$2ef1a,a0	; or $2ef28
	move.b	#$60,(a0)	; bra

	; skip checksum at level 2
	lea	$3db06,a0
	move.w	#$4e71,(a0)	; nop
	lea	$3dbb8,a0
	move.b	#$60,(a0)	; bra

; do a copy of trackloader at safe place
	lea	Trackloader(pc),a0
	lea	ADDRTRKLD,a1
	move.l	#(sizetk/4)-1,d7
cp	move.l	(a0)+,(a1)+
	dbf	d7,cp

; Full Trainer 
; (ingame trainer "KILLER" during play - skip level with F1-F8)
; test if active trainer : infinite lives/time
	lea	trainer(pc),a0
	tst.b	(a0)
	beq.s	.notr

	move.b	#$4A,$2C9F0		; unlimited lives
	move.b	#$4A,$370CC		; unlimited time
	; invulnerability
	bset	#0,$2AF0A
	bset	#0,$2BA14
	bset	#0,$2BAFE
	bset	#0,$2BB44
	bset	#0,$2BB90
	bset	#0,$2BBEE
	bset	#0,$2BC24
	bset	#0,$33A3A
	bset	#0,$33CC2
	bset	#0,$33D3C
	bset	#0,$37124

.noTrainer
	jmp	$23800	; start main Toki
trainer	dc.w	0
;-----------------------------------------
loadmain
	lea	FileMain(pc),a0
	bsr.s	Trackloader
	bra	patchmain
;--------------------------------------- Files list
FileMain dc.l	$23800
	dc.l	1485*512	; main program ice
	dc.l	248*512		
Files	dc.l	11*512		;levels track 1 "level1"
file2	dc.l	195*512		; 198 : track 18 "level2"
file3	dc.l	358*512		; 363 : track 33 "level3"
file4	dc.l	520*512		; 528 : track 48 "level4"
file5	dc.l	675*512		; 693 : track 63 "level5"
file6	dc.l	842*512		; 869 : track 79 "level6"
file7	dc.l	963*512		; 990 : track 90 "level7"
File8	dc.l	1087*512	; loader 1122 : track 102
File9	dc.l	1161*512	; scores ice 1199 : track 109
File10	dc.l	1191*512	; intro ice 1232 : track 112
File11	dc.l	1301*512	; outro ice 1342 : track 122

;----- TrackLoader
Trackloader:	
	include "trackloader.asm"
sizetk=*-Trackloader

;----------------------------------------- DePacker
; ICE Depacker
; a0=source
Decrunch:
	include	"tokiunice.asm"

sizet=*-starter

		End
